import { Container } from 'inversify';
export interface IStatefulService<TState> {
    state: TState;
}
export declare type StateUpdater<TState> = Partial<TState> | ((prev: TState) => Partial<TState> | undefined) | undefined;
export declare type AfterFn<TState> = (state: TState) => void;
export declare type HandlerFn = () => void;
export interface StateChange<TState> {
    service: IStatefulService<TState>;
    updater: StateUpdater<TState>;
    after?: AfterFn<TState>;
}
export declare class StateTracker {
    static bindToContainer(container: Container): void;
    handlers: Set<HandlerFn>;
    private changes;
    private scheduledUpdate;
    private synchronous;
    enqueueUpdate<TState>(update: StateChange<TState>): void;
    private handleUpdate;
}
//# sourceMappingURL=state-tracker.d.ts.map